using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using System.Transactions;
using System.Data.SqlClient;

namespace Exferia_Maestros._1_Datos
{
    public class MAE_ContactosTelefonos_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }


        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener
        private dynamic g_dnm_Modelo_Obtener = null;
        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                  " SELECT distinct " +
                      nameof(MAE_ContactosTelefonos) + "." + nameof(MAE_ContactosTelefonos.id) + "," +
                      nameof(MAE_ContactosTelefonos) + "." + nameof(MAE_ContactosTelefonos.telefono) + "," +
                      nameof(MAE_ContactosTelefonos) + "." + nameof(MAE_ContactosTelefonos.idContacto) + "," +
                      nameof(MAE_ContactosTelefonos) + "." + nameof(MAE_ContactosTelefonos.idTelefonoTipo) +
                  " FROM " + nameof(MAE_ContactosTelefonos) +
                  " WHERE " + nameof(MAE_ContactosTelefonos.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<MAE_ContactosTelefonos>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_ContactosTelefonos_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        #endregion

        #region MODELOS

        #region Modelo Simple
        private MAE_ContactosTelefonos g_mdl_MAE_ContactosTelefonos = null;
        public MAE_ContactosTelefonos Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                 //WHERE
                                 " WHERE " + nameof(MAE_ContactosTelefonos) + "." + nameof(MAE_ContactosTelefonos.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_ContactosTelefonos_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MAE_ContactosTelefonos;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                             object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_MAE_ContactosTelefonos = obj_Exferia_Entities.Database.SqlQuery<MAE_ContactosTelefonos>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_ContactosTelefonos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #region Modelo Listado
        private List<MAE_ContactosTelefonos> g_lst_MAE_ContactosTelefonos = null;

        public List<MAE_ContactosTelefonos> Obtener_ModeloListado_Por_idContacto(long lng_idContacto)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                 //WHERE
                                 " WHERE " + nameof(MAE_ContactosTelefonos) + "." + nameof(MAE_ContactosTelefonos.idContacto) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  lng_idContacto)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_ContactosTelefonos_Datos) + "/" + nameof(Obtener_ModeloListado_Por_idContacto), true);
            }

            return g_lst_MAE_ContactosTelefonos;
        }
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                   object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el modelo
                g_lst_MAE_ContactosTelefonos = obj_Exferia_Entities.Database.SqlQuery<MAE_ContactosTelefonos>(_str_SQL, _arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_ContactosTelefonos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(MAE_ContactosTelefonos) + "." + nameof(MAE_ContactosTelefonos.id) + " , " +
                    nameof(MAE_ContactosTelefonos) + "." + nameof(MAE_ContactosTelefonos.telefono) + " , " +
                    nameof(MAE_ContactosTelefonos) + "." + nameof(MAE_ContactosTelefonos.idContacto) + " , " +
                    nameof(MAE_ContactosTelefonos) + "." + nameof(MAE_ContactosTelefonos.idTelefonoTipo) +
                " FROM " + nameof(MAE_ContactosTelefonos);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                MAE_ContactosTelefonos mdl_MAE_ContactosTelefonos_AGrabar = (MAE_ContactosTelefonos)_mdl_obj;
                MAE_ContactosTelefonos mdl_MAE_ContactosTelefonos_DatosViejos = new MAE_ContactosTelefonos();

                // Ver si existe ######################################################################
                MAE_ContactosTelefonos mdl_MAE_ContactosTelefonos_Final = Obtener_Modelo_Por_Id(mdl_MAE_ContactosTelefonos_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_MAE_ContactosTelefonos_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos Viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_ContactosTelefonos_Final, mdl_MAE_ContactosTelefonos_DatosViejos, false, false);

                    //Cargar los Datos Nuevos para la Trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_ContactosTelefonos_AGrabar, mdl_MAE_ContactosTelefonos_Final, false, false);

                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(MAE_ContactosTelefonos) +
                                           " SET " +
                                               nameof(MAE_ContactosTelefonos.telefono) + "=@telefono," +
                                               nameof(MAE_ContactosTelefonos.idContacto) + "=@idContacto," +
                                               nameof(MAE_ContactosTelefonos.idTelefonoTipo) + "=@idTelefonoTipo" +
                                           " WHERE " +
                                               nameof(MAE_ContactosTelefonos.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@telefono",  mdl_MAE_ContactosTelefonos_AGrabar.telefono),
                        new SqlParameter("@idContacto",  mdl_MAE_ContactosTelefonos_AGrabar.idContacto),
                        new SqlParameter("@idTelefonoTipo",  mdl_MAE_ContactosTelefonos_AGrabar.idTelefonoTipo),
                        new SqlParameter("@id",  mdl_MAE_ContactosTelefonos_AGrabar.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_MAE_ContactosTelefonos_AGrabar.id;
                }
                else
                {
                    mdl_MAE_ContactosTelefonos_Final = new MAE_ContactosTelefonos();

                    //Tipo de Accdion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos Del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_ContactosTelefonos_AGrabar, mdl_MAE_ContactosTelefonos_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(MAE_ContactosTelefonos) +
                                               " (" +
                                                       nameof(MAE_ContactosTelefonos.telefono) + "," +
                                                       nameof(MAE_ContactosTelefonos.idContacto) + "," +
                                                       nameof(MAE_ContactosTelefonos.idTelefonoTipo) +
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(MAE_ContactosTelefonos.id) +
                                               " VALUES " +
                                               " ( " +
                                                   "@telefono," +
                                                   "@idContacto," +
                                                   "@idTelefonoTipo" +
                                               " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@telefono",  mdl_MAE_ContactosTelefonos_AGrabar.telefono),
                        new SqlParameter("@idContacto",  mdl_MAE_ContactosTelefonos_AGrabar.idContacto),
                        new SqlParameter("@idTelefonoTipo",  mdl_MAE_ContactosTelefonos_AGrabar.idTelefonoTipo)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                //Grabar un registro de trazabilidad con los datos de la transaccion realizada
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_ContactosTelefonos), mdl_MAE_ContactosTelefonos_DatosViejos, mdl_MAE_ContactosTelefonos_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_ContactosTelefonos_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                MAE_ContactosTelefonos mdl_MAE_ContactosTelefonos_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if(mdl_MAE_ContactosTelefonos_Final != null)
                {
                    #region DELETE
                    string str_SQL_Delete = " DELETE FROM  " + nameof(MAE_ContactosTelefonos) +
                                            " WHERE " +
                                                nameof(MAE_ContactosTelefonos.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Delete = new object[]
                    {
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Delete
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_ContactosTelefonos), null, mdl_MAE_ContactosTelefonos_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }
                    
                //Devolver tambien el objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_ContactosTelefonos_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion

    }
}
